---
title: Access debugging in add-ons
slug: Tools/Debugger/How_to/Access_debugging_in_add-ons
---
<div>{{ToolsSidebar}}</div><div class="warning">
<p>We are planning to deprecate the use by Firefox add-ons of the techniques described in this document. Don't write new add-ons that use these techniques.</p>
</div>

<p>The following items are accessible in the context of chrome://browser/content/debugger.xul (or, in version 23 beta, chrome://browser/content/devtools/debugger.xul):</p>

<ul>
 <li>window.addEventListener("Debugger:EditorLoaded") - called when the read-only script panel loaded.</li>
 <li>window.addEventListener("Debugger:EditorUnloaded")</li>
</ul>

<p>Relevant files:</p>

<ul>
 <li>chrome://browser/content/devtools/debugger-controller.js</li>
 <li>chrome://browser/content/devtools/debugger-toolbar.js</li>
 <li>chrome://browser/content/devtools/debugger-view.js</li>
 <li>chrome://browser/content/devtools/debugger-panes.js</li>
</ul>

<p>Unfortunately there is not yet any API to evaluate watches/expressions within the debugged scope, or highlight elements on the page that are referenced as variables in the debugged scope. (currently a work in progress, see bug <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=653545">653545</a>.)</p>
